Global("EVRe", {})
local ver = {"HealerProc",7,"2011/09/15","/Nikon"}

function RegEv (ER)
for v,t in pairs(ER) do
	if string.find(v, "[A-Z]+T_+[A-Z]") then common.RegisterEventHandler(t,v) end
end
end

function RegERk (ER)
for v,t in pairs(ER) do
	if not string.find(v, "[A-Z]+T_+[A-Z]") then common.RegisterReactionHandler(t,v) end
end
end

function UnRegEv (ER)
for v,t in pairs(ER) do
	if string.find(v, "[A-Z]+T_+[A-Z]") then common.UnRegisterEventHandler(t,v) end
end
end

function UnRegERk (ER)
for v,t in pairs(ER) do
	if not string.find(v, "[A-Z]+T_+[A-Z]") then common.UnRegisterReactionHandler(t,v) end
end
end

function Reg (ER)
RegEv(ER)
RegERk(ER)
end

function UnReg (ER)
UnRegEv(ER)
UnRegERk(ER)
end

----- EVENTS -----
EVRe["SCRIPT_ADDON_INFO_REQUEST"] = function(params)
if params.target == common.GetAddonName() then
	userMods.SendEvent( "SCRIPT_ADDON_INFO_RESPONSE", {
		sender = params.target,
		desc = ver[1].." v."..tostring(ver[2]).." ["..ver[3]..ver[4].."]"
		--showDNDButton = false,
		--showHideButton  = false,
		--showSettingsButton = false
		--addonsBlocked = {}
	})
end
end

EVRe["U_EVENT_ADDON_MEM_USAGE_REQUEST"] = function(params)
userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_RESPONSE", {sender = common.GetAddonName(), memUsage = gcinfo()})
end

EVRe["EVENT_AVATAR_CREATED"] = function(params)
if not changeRoom or unit.GetClass(avatar.GetId()).className ~= "PRIEST" then
	common.StateUnloadManagedAddon("UserAddon/"..common.GetAddonName())
else
	wt:Init()
end
end

EVRe["EVENT_UNIT_MOOD_CHANGED"] = function(params)
if params.unitId == wt.avaId and AutoStopCast then
	wt.stcast = not wt.stcast
end
end

EVRe["EVENT_ACTION_PROGRESS_START"] = function(params)
local dp = params.duration - params.progress
if wt.stcast and dp > wt.sr[1] and dp < wt.sr[2] and object.IsInCombat(wt.avaId) then
	--common.LogInfo("","StopCasting ",params.name," ",tostring(dp)," ",tostring(wt.stcast))
	avatar.StopCasting()
end
end

EVRe["EVENT_OBJECT_BUFF_ADDED"] = function(params)
local pos
if params.objectId == wt.avaId then
	local bff = object.GetBuffInfo(params.buffId)
	local chb = wt:ChckBuff(bff)
	if chb > 0 then
		wt.bf[chb].ic:SetBackgroundTexture(bff.texture)
		wt.bf[chb].buffId = params.buffId
		wt.bf[chb].buffTimer = (500+bff.remainingMs)/1e3
		wt.bf[chb].txt:SetVal("Timer",userMods.ToWString(string.format('%d',wt.bf[chb].buffTimer)))
		--wt.bf[chb].txt:SetVal("Timer",userMods.ToWString(string.format('%d',(500+bff.remainingMs)/1e3)))
		pos = wt.bf[chb].wd:GetPlacementPlain()
		pos.sizeX = wt.bf[chb].size/wt.bf[chb].prm.stackLimit
		wt.bf[chb].wd:SetPlacementPlain(pos)
		wt.bf[chb].wd:Show(true)
		wt:SE()
	end
end
end

EVRe["EVENT_OBJECT_BUFFS_ELEMENT_CHANGED"] = function(params)
--common.LogInfo("","EVENT_OBJECT_BUFFS_ELEMENT_CHANGED")
if params.objects[wt.avaId] then
	local bff,pos
	for v,t in wt.bf do
		if t.buffId > 0 then
			bff = object.GetBuffInfo(t.buffId)
			--t.txt:SetVal("Timer",userMods.ToWString(string.format('%d',(500+bff.remainingMs)/1e3)))
			t.buffTimer = (500+bff.remainingMs)/1e3
			t.txt:SetVal("Timer",userMods.ToWString(string.format('%d',t.buffTimer)))
			pos = t.wd:GetPlacementPlain()
			--pos.sizeX = bff.stackCount * t.size / bff.stackLimit
			pos.sizeX = bff.stackCount * t.size / t.stackLimit
			t.wd:SetPlacementPlain(pos)
			if(bff.durationMs - bff.remainingMs) < 1e3 then
				t.wd:PlayFadeEffect(0.9, 0.4, 1500, EA_SYMMETRIC_FLASH )
			end
		end
	end
end
end

EVRe["EVENT_OBJECT_BUFFS_CHANGED"] = function(params)
if params.objectId == wt.avaId then
	--common.LogInfo("","EVENT_OBJECT_BUFFS_CHANGED")
	local tbl,flg,ttt = object.GetBuffs(wt.avaId)
	for u,p in wt.bf do
		if p.buffId > 0 then
			flg = false
			for v,t in tbl do
				if t == p.buffId then
					flg = true
					break
				end
			end
			ttt = 0
			if flg then ttt = object.GetBuffInfo(p.buffId).stackCount end
			p.wd:Show(flg)
			p.buffId = flg and p.buffId or 0
		end
	end
end
end

---- Reactions ----